USE teachcloud_db;

DROP TABLE IF EXISTS `basic_teach_course`;
CREATE TABLE `basic_teach_course` (
                                      `id` bigint NOT NULL COMMENT '主键',
                                      `school_id` bigint DEFAULT NULL COMMENT '学校id',
                                      `org_id` bigint DEFAULT NULL COMMENT '机构id',
                                      `user_id` bigint DEFAULT NULL COMMENT '用户ID',
                                      `course_id` bigint DEFAULT NULL COMMENT '课程ID',
                                      `enable` tinyint DEFAULT '1' COMMENT '是否启用？1-是 ；0-否',
                                      `create_id` bigint DEFAULT NULL COMMENT '创建人',
                                      `create_time` bigint DEFAULT NULL COMMENT '创建时间',
                                      `update_id` bigint DEFAULT NULL COMMENT '更新人',
                                      `update_time` bigint DEFAULT NULL COMMENT '更新时间',
                                      PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='老师和课程关联表';

CREATE INDEX exam_detail_school_id_IDX USING BTREE ON exam_detail (school_id);

alter table exam_student add UNIQUE index `unique_ticket_number_idx`(`school_id`,`ticket_number`);

ALTER TABLE `exam_detail`
    ADD COLUMN `backup_count` DOUBLE NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' AFTER `print_count`;

ALTER TABLE `exam_print_plan`
    CHANGE COLUMN `backup_count` `backup_count` DOUBLE NOT NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' ;

ALTER TABLE `basic_print_config`
    CHANGE COLUMN `backup_count` `backup_count` DOUBLE NULL DEFAULT NULL COMMENT '试卷、题卡备份数量（0-1为按比例，大于等于1为按数量）' ;\

ALTER TABLE `basic_card_rule`
    CHANGE COLUMN `objective_attention` `objective_attention` TEXT NULL COMMENT '客观题注意事项' ,
    CHANGE COLUMN `subjective_attention` `subjective_attention` TEXT NULL COMMENT '主观题注意事项' ;

ALTER TABLE `exam_detail` DROP COLUMN `print_count`;

CREATE TABLE `exam_detail_course_paper_type` (
                                                 `id` BIGINT(20) NOT NULL,
                                                 `exam_detail_course_id` BIGINT(20) NOT NULL,
                                                 `paper_type` VARCHAR(5) NOT NULL COMMENT '卷型',
                                                 PRIMARY KEY (`id`));
ALTER TABLE `exam_detail_course_paper_type`
    ADD INDEX `idx_exam_detail_course_id` (`exam_detail_course_id` ASC);

ALTER TABLE `exam_paper_structure`
    CHANGE COLUMN `objective_structure` `objective_structure` MEDIUMTEXT NULL DEFAULT NULL COMMENT '客观题试卷结构JSON' ,
    CHANGE COLUMN `subjective_structure` `subjective_structure` MEDIUMTEXT NULL DEFAULT NULL COMMENT '主观题试卷结构JSON' ,
    CHANGE COLUMN `paper_info_json` `paper_info_json` MEDIUMTEXT NULL DEFAULT NULL COMMENT '整个试卷信息json（前端提供的全部信息）' ;

ALTER TABLE basic_student MODIFY COLUMN student_code varchar(100) NOT NULL COMMENT '学生编号';
ALTER TABLE basic_student MODIFY COLUMN student_name varchar(100) NOT NULL COMMENT '学生姓名';
ALTER TABLE exam_student MODIFY COLUMN student_code varchar(100) NOT NULL COMMENT '考生代码';
ALTER TABLE exam_student MODIFY COLUMN student_name varchar(100) NOT NULL COMMENT '考生姓名';
ALTER TABLE sys_user MODIFY COLUMN code varchar(100) NULL COMMENT '工号';
ALTER TABLE basic_course MODIFY COLUMN code varchar(100) NOT NULL COMMENT '课程编码';
ALTER TABLE sys_user MODIFY COLUMN mobile_number varchar(30) NULL COMMENT '手机号';

ALTER TABLE `exam_task_sync`
    ADD COLUMN `paper_type` VARCHAR(10) NULL COMMENT '试卷类型' AFTER `paper_number`;

ALTER TABLE `basic_template`
    ADD COLUMN `diallel` TINYINT(1) NULL COMMENT '考生信息是否双列显示' AFTER `enable`,
    ADD COLUMN `text_desc` VARCHAR(500) NULL COMMENT '文字说明' AFTER `diallel`;

ALTER TABLE `exam_paper_structure`
    CHANGE COLUMN `paper_type` `paper_type` VARCHAR(20) CHARACTER SET 'utf8mb4' COLLATE 'utf8mb4_general_ci' NULL DEFAULT NULL COMMENT '试卷类型' ;

ALTER TABLE `exam_paper_structure`
    CHANGE COLUMN `paper_number` `paper_number` VARCHAR(50) CHARACTER SET 'utf8mb4' COLLATE 'utf8mb4_general_ci' NOT NULL COMMENT '试卷编号' ;

